__doc__ = 'misc functions used by HiperDom'

class alreadyRendered:
	"""This class is used to allow hdom: renderer methods to return strings;
	those strings are wrapped in an alreadyRendered object so that toxml()
	doesn't try to escape them.
	"""
	def __init__ (self, s):
		self.s = s
		self.type = 'alreadyRendered'

class alreadyRenderedNode:
	"""This class is used in conjunction with alreadyRendered to fool toxml()
	"""
	def __init__ (self, data, document = None):
		self._node = data
		self._document = document
		self.type = 'alreadyRendered'
		self.nodeType = self.type
		self.attributes = []
		self.childNodes = []

	def toxml (self):
		return self._node.s
	
	def cloneNode (self, deep=0):
		return self

# hack
import xml.dom.core
xml.dom.core.NODE_CLASS ['alreadyRendered'] = alreadyRenderedNode


try:
	from DocumentTemplate.cDocumentTemplate import isFunctionType, isSimpleType
except:
	from DocumentTemplate.pDocumentTemplate import isFunctionType, isSimpleType
import sys

def evaluate (name, context, REQUEST, assets):
	"locate and evaluate a name in the Zope context"
	# Here we specifically don't want any exception handling -
	# any error in the following lines should be handling by
	# the normal Zope exception handling so that the user sees
	# an error message page
	#obj = context.restrictedTraverse (name)
	if assets.has_key (name):
		obj = assets[name]
	elif hasattr (context, 'has_key') and context.has_key (name):
		obj = context[name]
	else:
		obj = context.aq_acquire (name)
	if hasattr (context, '_push'):
		# We have a TemplateDict and must pass it along
		context._push (assets)
		assets = context
	if isSimpleType (type (obj)):
		pass
	elif hasattr (obj, 'isXmlTemp') and obj.isXmlTemp:
		obj = apply (obj, (context, REQUEST), assets)
	elif hasattr (obj, 'isDocTemp') and obj.isDocTemp:
		if not ((type (context is type ({}))) or hasattr (context, '__getitem__')):
			context = REQUEST
		obj = apply (obj, (None, context), assets)
	elif isFunctionType (type (obj)) or hasattr (obj, '__call__'):
		try:
			obj = apply (obj, (context, REQUEST), assets)
		except TypeError, what:
			# hahahahahahahahahahahahack
			if str (what)[:30] == 'too many arguments; expected 2':
				obj = apply (obj, (context,), assets)
			else:
				raise
	else:
		try:
			obj = apply (obj, (context, REQUEST), assets)
		except AttributeError, what:
			if str (what)[:26] != 'no __call__ method defined':
				raise
		except TypeError, what:
			if str (what)[:20] != 'call of non-function':
				raise
	return obj

